
local MAJOR = "StarLibError-1.0" 
local MINOR = 1
assert(LibStub, MAJOR.." requires LibStub") 
local StarLibError = LibStub:NewLibrary(MAJOR, MINOR)
if not StarLibError then return end

if not StarLibError.__index then
	StarLibError.__index = StarLibError
	StarLibError.pool = setmetatable({}, {__mode = "k"})
end

function StarLibError:New(handler) 
	if self ~= StarLibError or type(handler) ~= "function" then return end
	
	local obj = next(self.pool)

	if obj then
		self.pool[obj] = nil
	else
		obj = {}
	end

	setmetatable(obj, self)
	
	obj.handler = handler
	
	return obj	
end

function StarLibError:Del(ev)
	if self == StarLibError then
		LibProperty.pool[ev] = true
	else
		LibProperty.pool[self] = true
	end
end

function StarLibError:Print(text)
	if self.handler then
		self.handler(text)
	end
end

